--[[
Project name: DkpBidder
Developed by: Eadel
Website: http://www.arthion.fr/aldea
Description: DKP ingame management
License: All Rights Reserved unless otherwise explicitly stated. 
File: DKPBidder.lua
File description: Core
]]

local bidders = {};
DKPBidder= LibStub("AceAddon-3.0"):NewAddon("DKPBidder","AceHook-3.0","AceConsole-3.0","AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("DKPBidder", true)


--Loading addon
function DKPBidder:OnInitialize()	
DKPBidder:RegisterChatCommand("dkpbidder", "SlashCommand")
DKPBidder:RegisterChatCommand("dkp", "SlashCommand")
self.db = LibStub("AceDB-3.0"):New("DKPBidderDB")
end


--Enabling addon
function DKPBidder:OnEnable()	
		DKPBidder:RegisterEvent("CHAT_MSG_WHISPER","eventHandler");
		DKPBidder:RegisterEvent("CHAT_MSG_RAID","eventHandler");
		DKPBidder:RegisterEvent("CHAT_MSG_RAID_LEADER","eventHandler");
		DKPBidder:RegisterEvent("CHAT_MSG_CHANNEL","eventHandler");
		if (HeadCount) then
			DKPBidder:Hook(HeadCount,"lootManagementUpdate", "HeadcountHook", true)
		end
		print(L["addon.init"])
		if DKPInfo.timestamp > self.db.global.DkpInfo.timestamp then
		print (L["DB.compare"]..DKPInfo.date..L["DB.compare2"]..self.db.global.DkpInfo.date)
		print(L["DB.updating"])
		self.db.global.DkpInfo = DKPInfo
		self.db.global.DkpData = gdkp
		else 
		print (L["DB.uptodate"])
		end
end

function DKPBidder:SlashCommand(input)
	if (input == "print") then
			DKPBidder:printBidders();
	elseif (input == "clear") then
		wipe(bidders);
		print(L["BiddersCleared"])
	else
		print (L["Addon.usage"]) 
		print (L["addon.usage2"]) 
		print (L["addon.usage3"]) 
		print (L["addon.usage4"]) 
	end
end

-- Event Handler
function DKPBidder:eventHandler(event)
	
	
	-- Detect +1 in raid or raid leader chan, add bidder un bidder list
	if (event == "CHAT_MSG_RAID" or event == "CHAT_MSG_RAID_LEADER") then
		
		_args = GetArgs(arg1, " ");
		if ((_args[1] == "+1")) then
			
				table.insert(bidders, arg2);
				for index,value in ipairs(bidders) do 
					print(index.." : "..value);
				end;
		end;
  	end;
	
	if (event == "CHAT_MSG_WHISPER") then
		
		_args = GetArgs(arg1, " ");
		
		if (_args[1] == "dkp") then
			if (_args[2] ~= nil) then
				if(gdkp.players[_args[2]] ~= nil) then
					SendChatMessage(L["points.of"].._args[2].." : "..DKPBidder:grabDkp(_args[2]).." dkp.", "WHISPER", this.language, arg2);
				else 
					SendChatMessage(_args[2]..L["notinroster"],  "WHISPER", this.language, arg2);
				end
			elseif(gdkp.players[arg2] ~= nil) then
				SendChatMessage(L["your.points"]..DKPBidder:grabDkp(arg2).." dkp.", "WHISPER", this.language, arg2);
			else 
				SendChatMessage(L["younotinroster"],  "WHISPER", this.language, arg2);
				
			
			end;
		end;
		
		if (_args[1] == "clear") then
		wipe(bidders);
		print(L["BiddersCleared"])
		end;
		
		if (_args[1] == "print") then

			DKPBidder:printBidders();

		end; -- end of stop cond
		
		
	end; -- end of whisper event
	
	
end;

function GetArgs(message, separator)
	if (message == nil) then
		return;
	end;
	-- Declare 'args' variable.
	local args = {};

	-- Declare 'i' integer.
	i = 0;

	-- Search for seperators in the string and return
	-- the separated data.
	
	for value in string.gmatch(message, "[^"..separator.."]+") do
		i = i + 1;
		args[i] = value;
	end -- end for

	-- Submit the filtered data.
	return args;
end -- end GetArgs()

function DKPBidder:printBidders()
for index,value in ipairs(bidders) do 
				if(gdkp.players[value] ~= nil) then
					SendChatMessage(index..L["points.of"]..value.." : "..DKPBidder:grabDkp(value).." dkp.", "RAID", this.language);	
				else
					SendChatMessage(index..". "..arg2..L["notinroster"], "RAID", this.language);
				end
			end;
			wipe(bidders);
			print(L["BiddersCleared"])
end

function DKPBidder:DKP_Sub(msg)
	DKPBidder:MATH_DKP(msg,"sub");
end;

function DKPBidder:DKP_Add(msg)
	DKPBidder:MATH_DKP(msg,"add");
end;

function DKPBidder:MATH_DKP(msg,_type)
	_args = GetArgs(msg, " ");
	
	if _type == "add" then
						self.db.global.DkpData.players[_args[1]]["dkp_current"] = gself.db.global.DkpData.players[_args[1]]["dkp_current"] + _args[2] ;
						SendChatMessage("<DKP>".._args[1]..L["win"].._args[2].." dkp", "RAID", this.language);

	elseif _type == "sub" then
						self.db.global.DkpData.players[_args[1]]["dkp_current"] = self.db.global.DkpData.players[_args[1]]["dkp_current"] - _args[2] ;
						SendChatMessage("<DKP>".._args[1]..L["loose"].._args[2].." dkp", "RAID", this.language);
	end;	
end;

-- Hook with headcount
function DKPBidder:HeadcountHook(Addon,raidId, lootId, playerName, source, lootCost, lootNote)
 DKPBidder:DKP_Sub(playerName.." "..lootCost)
end

function DKPBidder:grabDkp(player)
--print(self.db.global.DkpData.players[player]["dkp_current"])
return self.db.global.DkpData.players[player]["dkp_current"]
end